/*
 * $Copyright Open Broadcom Corporation$
 *
 * $Id: wanppp.h,v 1.11.32.2 2003/10/31 21:31:35 mthawani Exp $
 */

#ifndef _wanppp_h_
#define _wanppp_h_

/*
  Definitions and declarations to support the WAN IPConnection service.
*/

#define VAR_ConnectionType		0
#define VAR_PossibleConnectionTypes		1
#define VAR_ConnectionStatus		2
#define VAR_Uptime		3
#define VAR_UpstreamMaxBitRate		4
#define VAR_DownstreamMaxBitRate	5
#define VAR_LastConnectionError		6
#define VAR_RSIPAvailable		7
#define VAR_NATEnabled		8
#define VAR_ExternalIPAddress		9
#define VAR_PortMappingNumberOfEntries		10
#define VAR_PortMappingEnabled		11
#define VAR_PortMappingLeaseDuration		12
#define VAR_RemoteHost		13
#define VAR_ExternalPort		14
#define VAR_InternalPort		15
#define VAR_PortMappingProtocol		16
#define VAR_InternalClient		17
#define VAR_PortMappingDescription		18


typedef enum { 
    PPP_UNCONFIGURED, 
    PPP_CONNECTING, 
    PPP_AUTHENTICATING,
    PPP_CONNECTED, 
    PPP_PENDINGDISCONNECT, 
    PPP_DISCONNECTING,
    PPP_DISCONNECTED	  
} ppp_conn_t;


#define CONNECTION_TIMEOUT   20

struct WANPPPConnectionData {
    ppp_conn_t	connection_status;
    int		connection_timeout;  /* timeout in seconds */
    time_t    connected_time;
    struct in_addr external_ipaddr;
    int igd_generation;
    int nportmappings;
    int upstrmaxbitrate;
    int dnstrmaxbitrate;
    timer_t eventhandle;
};

typedef struct WANPPPConnectionData WANPPPConnectionData, *PWANPPPConnectionData;

#endif // _wanppp_h_
